/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TPBP                                                     */
/* Tabela : TIPOBAIXAPAG                                                      */
/*                                                                            */
/* Criao:                                                                   */
/* 26/02/2006 - ARNALDO COUTINHO BRITO JNIOR                                 */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_TPBP' and
            type = 'TR'                      and
            u.uid = o.uid           	     and
            u.name = USER)
   DROP TRIGGER DTULTATU_TPBP
GO

CREATE TRIGGER DTULTATU_TPBP
ON TIPOBAIXAPAG
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'TIPOBAIXAPAG', null, 'CDTPBAIXAPAG=' + CDTPBAIXAPAG + ';',
      GETDATE() FROM DELETED)

   END
   ELSE BEGIN
      UPDATE TIPOBAIXAPAG
      SET DTULTATUTPBP = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(TIPOBAIXAPAG.CDTPBAIXAPAG,0) = ISNULL(INSERTED.CDTPBAIXAPAG,0  )) AND
            (ISNULL(TIPOBAIXAPAG.IDBAIXAUTILP,0) = ISNULL(INSERTED.IDBAIXAUTILP,0  )) AND
            (ISNULL(TIPOBAIXAPAG.VRMAXDOCCNAB,0) = ISNULL(INSERTED.VRMAXDOCCNAB,0  )) AND
            (ISNULL(TIPOBAIXAPAG.NMTPBAIXAPAG,0) = ISNULL(INSERTED.NMTPBAIXAPAG,0  )) AND
            (ISNULL(TIPOBAIXAPAG.IDCTBLBXPAG, 0) = ISNULL(INSERTED.IDCTBLBXPAG, 0  )) AND
            (ISNULL(TIPOBAIXAPAG.IDBAIXAUTILP,0) = ISNULL(INSERTED.IDBAIXAUTILP,0  )) AND
            (ISNULL(TIPOBAIXAPAG.CDTPCREDBANC,0) = ISNULL(INSERTED.CDTPCREDBANC,0  ));

   END;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_TPBP','4.11.072';
GO

